## shark 3.1.2+ds1

=== debian/changelog ===
shark (3.1.2+ds1-1) unstable; urgency=medium

  * New usptream release.
  * Update patch queue.
    - Refresh the following patches:
      - Fix-CBLAS-detection-on-Debian.patch,
      - Fix-CMake-package-creation.patch,
      - Fix-missing-iostream-include.patch,
      - Use-GNUInstallDirs.patch.
    - Drop HDF5 testing patch series, applied upstream.
    - Drop HDF5 detection patch, applied upstream.
  * Exclude test cases labeled as slow from running.
  * Silence svnversion noise during build.
  * Minor enhancements to rules file.
    - Add comment for DH_VERBOSE option.
    - Drop superfluous query for DEB_HOST_MULTIARCH.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 30 Aug 2016 12:42:09 +0100

## shark 3.1.3+ds1

=== examples/Supervised/Makefile ===

GPP = g++
# GPP = gfilt
# GPP = gfilt /cand:L

COMPILERPARAMS = -DNDEBUG -I../../include/ -O3 -Wall -c
LINKERPARAMS = -lshark -L../../lib/ -lboost_serialization

# COMPILERPARAMS = -DDEBUG -I../../include/ -g -Wall -c
# LINKERPARAMS = -lshark_debug -L../../lib/ -lboost_serialization


all: CSvm CSvmGridSearch McSvm KernelRegression KernelSelection EvidenceOptimization


CSvm: CSvm.o
	${GPP} ${LINKERPARAMS} -o CSvm CSvm.o

CSvmGridSearch: CSvmGridSearch.o
	${GPP} ${LINKERPARAMS} -o CSvmGridSearch CSvmGridSearch.o

McSvm: McSvm.o
	${GPP} ${LINKERPARAMS} -o McSvm McSvm.o

KernelRegression: KernelRegression.o
	${GPP} ${LINKERPARAMS} -o KernelRegression KernelRegression.o

KernelSelection: KernelSelection.o
	${GPP} ${LINKERPARAMS} -o KernelSelection KernelSelection.o

EvidenceOptimization: EvidenceOptimization.o
	${GPP} ${LINKERPARAMS} -o EvidenceOptimization EvidenceOptimization.o

mytest: mytest.o
	${GPP} ${LINKERPARAMS} -o mytest mytest.o -lboost_serialization

%.o: %.cpp
	${GPP} ${COMPILERPARAMS} $<

clean:
	rm -f *.o *~ CSvm CSvmGridSearch McSvm KernelRegression KernelSelection mytest

=== debian/changelog ===
shark (3.1.3+ds1-2ubuntu5) artful; urgency=medium

  * No-change rebuild to pick up multiarchified libblas.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 15 Sep 2017 10:19:13 +0200

shark (3.1.3+ds1-2ubuntu4) artful; urgency=medium

  * Use gcc-6 also for testsuite

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 21 Aug 2017 12:50:56 +0200

shark (3.1.3+ds1-2ubuntu3) artful; urgency=medium

  * Force gcc-6 for now

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 21 Aug 2017 12:32:00 +0200

shark (3.1.3+ds1-2ubuntu2) artful; urgency=medium

  * Avoid FTBFS by building with -O2 on ppc64el

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 31 May 2017 20:07:31 +0200

shark (3.1.3+ds1-2ubuntu1) artful; urgency=medium

  * Allow stderr output in autopkgtests

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 31 May 2017 17:24:26 +0200

shark (3.1.3+ds1-2) unstable; urgency=medium

  * Fix FTBFS on mips and more architectures.
    - New patch Fix-build-on-MIPS.patch: override optimization level for
      selected sources.
    - New patch Update-list-of-slow-tests.patch: mark selected tests as
      slow to prevent testing from reaching a timeout.
    Thanks to Dejan Latinovic for investigating (Closes: #836599)
  * Drop superfluous Testsuite field.
  * Update description of binary packages.
  * Upgrade packaging to debhelper 10.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 01 Dec 2016 14:44:45 +0000

shark (3.1.3+ds1-1) unstable; urgency=medium

  * New upstream release. (Closes: #820701)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Fri, 02 Sep 2016 15:43:38 +0100

=== debian/control ===
Source: shark
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper (>= 10),
               libblas-dev | libblas.so,
               libboost-date-time-dev,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-serialization-dev,
               libboost-system-dev,
               libboost-test-dev,
               libboost-thread-dev,
               libhdf5-dev,
               gcc-6, g++-6
Build-Depends-Indep: doxygen,
                     graphviz,
                     python-sphinx
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/shark.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/shark.git
Homepage: http://image.diku.dk/shark

Package: libshark0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Shark machine learning library
 Shark is a modular C++ library for the design and optimization of adaptive
 systems. It provides methods for linear and nonlinear optimization, in
 particular evolutionary and gradient-based algorithms, kernel-based learning
 algorithms and neural networks, and various other machine learning techniques.
 .
 This package provides the shared libraries.

Package: libshark-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libblas-dev | libblas.so,
         libboost-dev,
         libhdf5-dev,
         libshark0 (= ${binary:Version})
Suggests: shark-doc
Description: development files for Shark
 Shark is a modular C++ library for the design and optimization of adaptive
 systems. It provides methods for linear and nonlinear optimization, in
 particular evolutionary and gradient-based algorithms, kernel-based learning
 algorithms and neural networks, and various other machine learning techniques.
 .
 This package provides the development files.

Package: shark-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends},
         libjs-mathjax
Description: documentation for Shark
 Shark is a modular C++ library for the design and optimization of adaptive
 systems. It provides methods for linear and nonlinear optimization, in
 particular evolutionary and gradient-based algorithms, kernel-based learning
 algorithms and neural networks, and various other machine learning techniques.
 .
 This package provides the documentation.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE = 1

# Hardening flags.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# Common cmake options.
CMAKE_BUILD_OPTIONS = \
	-DBUILD_SHARED_LIBS=ON \
	-DENABLE_CBLAS=ON \
	-DENABLE_OPENMP=ON \
	-DSHARK_INSTALL_DOC_DIR=share/doc/shark-doc \
	-DSHARK_INSTALL_EXAMPLE_DIR=share/doc/shark-doc/examples

# Disable build of testsuite if no check requested.
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
CMAKE_BUILD_OPTIONS += -DBUILD_TESTING=ON
else
CMAKE_BUILD_OPTIONS += -DBUILD_TESTING=OFF
endif

export CC=gcc-6
export CXX=g++-6

DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
ifeq ($(DEB_HOST_ARCH), ppc64el)
export DEB_CXXFLAGS_MAINT_STRIP = -O3
export DEB_CXXFLAGS_MAINT_APPEND = -O2 -Wall -pedantic
endif

%:
	dh $@

override_dh_auto_configure-arch:
	dh_auto_configure -- $(CMAKE_BUILD_OPTIONS) \
		-DBUILD_DOCUMENTATION=OFF \
		-DBUILD_EXAMPLES=OFF

override_dh_auto_configure-indep:
	dh_auto_configure -- $(CMAKE_BUILD_OPTIONS) \
		-DBUILD_DOCUMENTATION=ON \
		-DBUILD_EXAMPLES=ON \
		-DOPT_INSTALL_DOCUMENTATION=ON

override_dh_auto_test:
	dh_auto_test -- ARGS+="-LE 'slow'"

override_dh_installdocs-indep:
	dh_installdocs --indep
	dh_doxygen --indep \
		/usr/share/doc/shark-doc/html/doxygen_pages/html
	dh_sphinxdoc --indep --exclude=MathJax.js \
		/usr/share/doc/shark-doc/html/sphinx_pages

override_dh_compress:
	dh_compress --exclude=examples

=== debian/tests/control ===
Tests: build-examples
Restrictions: allow-stderr
Depends: build-essential,
         cmake,
         libboost-date-time-dev,
         libboost-filesystem-dev,
         libboost-program-options-dev,
         libboost-system-dev,
         libboost-test-dev,
         libboost-thread-dev,
         libshark-dev,
         pkg-config,
         shark-doc,
         gcc-6,
         g++-6

## shark 3.1.4%2Bds1

=== debian/control ===
--- 
+++ 
@@ -6,6 +6,7 @@
 Priority: optional
 Build-Depends: cmake,
                debhelper (>= 10),
+               dpkg-dev (>= 1.17.14),
                libblas-dev | libblas.so,
                libboost-date-time-dev,
                libboost-filesystem-dev,
@@ -14,12 +15,11 @@
                libboost-system-dev,
                libboost-test-dev,
                libboost-thread-dev,
-               libhdf5-dev,
-               gcc-6, g++-6
-Build-Depends-Indep: doxygen,
-                     graphviz,
-                     python-sphinx
-Standards-Version: 3.9.8
+               libhdf5-dev
+Build-Depends-Indep: doxygen <!nodoc>,
+                     graphviz <!nodoc>,
+                     python3-sphinx <!nodoc>
+Standards-Version: 4.1.1
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/shark.git
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/shark.git
 Homepage: http://image.diku.dk/shark
@@ -64,6 +64,7 @@
 Depends: ${misc:Depends},
          ${sphinxdoc:Depends},
          libjs-mathjax
+Built-Using: ${sphinxdoc:Built-Using}
 Description: documentation for Shark
  Shark is a modular C++ library for the design and optimization of adaptive
  systems. It provides methods for linear and nonlinear optimization, in
@@ -71,3 +72,4 @@
  algorithms and neural networks, and various other machine learning techniques.
  .
  This package provides the documentation.
+Build-Profiles: <!nodoc>

## shark 3.1.4+ds1

=== CMakeLists.txt ===
#####################################################################
#       Shark Machine Learning Library
#       Top-Level CMake driver file
#       Optionally included sub-probjects:
#         * Test/CMakeLists.txt
#         * examples/CMakeLists.txt
#         * doc/CMakeLists.txt
#####################################################################
project( shark )

set_property(GLOBAL PROPERTY USE_FOLDERS ON)
INCLUDE (CheckFunctionExists)

cmake_minimum_required( VERSION 2.8 )
cmake_policy(SET CMP0003 NEW)
if(POLICY CMP0042)
	cmake_policy(SET CMP0042 NEW)
endif()
if(POLICY CMP0053)
	cmake_policy(SET CMP0053 NEW)
endif()
#=========================================================
# Output directories.
if(NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
	set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${shark_BINARY_DIR}/bin")
endif()
if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
	if(UNIX)
		set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${shark_BINARY_DIR}/lib")
	else()
		set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${shark_BINARY_DIR}/bin")
	endif()
endif()
if(NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
	set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${shark_BINARY_DIR}/lib")
endif()
mark_as_advanced( 
	CMAKE_RUNTIME_OUTPUT_DIRECTORY
	CMAKE_LIBRARY_OUTPUT_DIRECTORY
	CMAKE_ARCHIVE_OUTPUT_DIRECTORY
)

#####################################################################
# Static/Shared libraries
#####################################################################
option(BUILD_SHARED_LIBS "Compile shark into a dynamic library instead of a static one." OFF)
if(BUILD_SHARED_LIBS)
	set(SHARK_USE_DYNLIB 1)
endif()

#####################################################################
# Version information
#####################################################################
option(BUILD_OFFICIAL_RELEASE "Is this an official Shark release." OFF )
mark_as_advanced( BUILD_OFFICIAL_RELEASE )

set(SHARK_VERSION_MAJOR 3)
set(SHARK_VERSION_MINOR 0)
set(SHARK_VERSION_PATCH 0)
set(SHARK_VERSION ${SHARK_VERSION_MAJOR}.${SHARK_VERSION_MINOR}.${SHARK_VERSION_PATCH})
set(SHARK_SOVERSION 0)


#####################################################################
#	Adjustments for cpack and deb package generation
#####################################################################
set(CPACK_GENERATOR TGZ DEB)
set(CPACK_PACKAGE_NAME "libshark")
set(CPACK_BUNDLE_NAME "libshark")
set(CPACK_PACKAGE_VENDOR "Institut fur Neuroinformatik, Ruhr-Universitaet Bochum")
set(CPACK_PACKAGE_VERSION_MAJOR ${SHARK_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${SHARK_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${SHARK_VERSION_PATCH})
set(CPACK_PACKAGE_VERSION ${SHARK_VERSION_MAJOR}.${SHARK_VERSION_MINOR}.${SHARK_VERSION_PATCH})
set(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_CURRENT_SOURCE_DIR}/COPYING.LESSER)

#Debian Compatible naming by default
if(CMAKE_SIZEOF_VOID_P MATCHES "8")
	set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE amd64)
else()
	set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE i386)
endif()
set(CPACK_PACKAGE_FILE_NAME ${CPACK_PACKAGE_NAME}_${CPACK_PACKAGE_VERSION}_${CPACK_DEBIAN_PACKAGE_ARCHITECTURE})
set(CPACK_DEBIAN_PACKAGE_DEPENDS "libboost-all-dev (>=1.54)")

set(CPACK_DEBIAN_PACKAGE_DESCRIPTION
	"SHARK is a modular C++ library for the design and optimization of adaptive systems. It provides methods for linear and nonlinear optimization, in particular evolutionary and gradient-based algorithms, kernel-based learning algorithms and neural networks, and various other machine learning techniques. SHARK serves as a toolbox to support real world applications as well as research indifferent domains of computational intelligence and machine learning. The sources are compatible with the following platforms: Windows, Solaris, MacOS X, and Linux."
)
set( CPACK_DEBIAN_PACKAGE_MAINTAINER "Christian Igel <c.igel@ieee.org>" )

#####################################################################
#    Adjust include, lib, example and doc paths for installation
#####################################################################
if( UNIX )
	set( SHARK_INSTALL_INCLUDE_DIR include/ )
	set( SHARK_INSTALL_LIB_DIR lib/ )
	set( SHARK_INSTALL_CONTRIB_DIR share/shark/contrib/ )
	set( SHARK_INSTALL_EXAMPLE_DIR share/shark/examples/ )
	set( SHARK_INSTALL_DOC_DIR share/shark/doc/ )
else()
	set( SHARK_INSTALL_INCLUDE_DIR include/shark/ )
	set( SHARK_INSTALL_LIB_DIR lib/ )
	set( SHARK_INSTALL_CONTRIB_DIR contrib/ )
	set( SHARK_INSTALL_EXAMPLE_DIR examples/ )
	set( SHARK_INSTALL_DOC_DIR doc )
endif()

#####################################################################
#           Enable installer and package generation
#####################################################################
 include( CPack )

#####################################################################
#           Explicit macro setup for debug configuration
#####################################################################
# enable or disable debugging, default is Release
if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE "Release")
endif()

if (UNIX)
    add_compile_options("$<$<CONFIG:DEBUG>:-Wall>")
endif()

list(APPEND COMPILE_DEFINITIONS_RELEASE NDEBUG)
message(STATUS "Will build: " ${CMAKE_BUILD_TYPE})

#####################################################################
#           Boost configuration
#####################################################################
set(Boost_USE_STATIC_LIBS OFF CACHE BOOL "use static libraries from Boost")
set(Boost_USE_MULTITHREADED ON)
add_definitions(-DBOOST_PARAMETER_MAX_ARITY=15)
add_definitions(-DBOOST_FILESYSTEM_VERSION=3)

# Should we link the boost test dynamically
if(NOT Boost_USE_STATIC_LIBS)
	add_definitions(-DBOOST_TEST_DYN_LINK)
	add_definitions(-DBOOST_ALL_DYN_LINK)
endif()

find_package( 
	Boost 1.48.0 REQUIRED COMPONENTS
	system date_time filesystem
	program_options serialization thread
	unit_test_framework
)

if(NOT Boost_FOUND)
	message(FATAL_ERROR "Please make sure Boost 1.48.0 is installed on your system")
endif()

if (WIN32)
	# disable autolinking in boost
	add_definitions( -DBOOST_ALL_NO_LIB )
endif()

include_directories(SYSTEM ${Boost_INCLUDE_DIR} )
link_directories( ${Boost_LIBRARY_DIR} )
if(UNIX)
	find_library( PTHREAD_LIBRARY pthread )
endif()

# Set the libraries needed by Shark
list(APPEND LINK_LIBRARIES ${Boost_LIBRARIES} ${PTHREAD_LIBRARY})

mark_as_advanced(Boost_DIR PTHREAD_LIBRARY)
message( STATUS "Using boost from " ${Boost_LIBRARY_DIR} )

#####################################################################
#		OpenMP
#####################################################################
option( ENABLE_OPENMP "Enable OpenMP" ON )
if( ENABLE_OPENMP )
	find_package( OpenMP QUIET )
	if( OPENMP_FOUND )
		message( STATUS "OpenMP found" )
		set(SHARK_USE_OPENMP 1)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}")

		set(SHARK_REQUIRED_C_FLAGS "${OpenMP_C_FLAGS}")
		set(SHARK_REQUIRED_CXX_FLAGS "${OpenMP_CXX_FLAGS}")
		set(SHARK_REQUIRED_EXE_LINKER_FLAGS "${OpenMP_EXE_LINKER_FLAGS}")

	else()
		message( STATUS "OpenMP not found" )
	endif()
else()
	message( STATUS "Building without OpenMP as requested." )
endif()

#####################################################################
#           HDF5 configuration
#####################################################################
find_package(HDF5 COMPONENTS C CXX HL QUIET)
mark_as_advanced(HDF5_DIR)
if(HDF5_FOUND)
	if(HDF5_C_COMPILER_EXECUTABLE AND HDF5_CXX_COMPILER_EXECUTABLE)
		message(STATUS "Checking HDF5 installation: HDF5 installation seems ok.")
		include_directories( ${HDF5_INCLUDE_DIRS} )
		list(APPEND LINK_LIBRARIES ${HDF5_LIBRARIES} ${HDF5_HL_LIBRARIES})
	else()
		message(STATUS "Checking HDF5 installation:HDF5 package might be broken.")
		if(NOT( HDF5_C_COMPILER_EXECUTABLE))
			message(STATUS "  C Compiler Extension not found.")
		endif()
		if(NOT( HDF5_CXX_COMPILER_EXECUTABLE))
			message(STATUS "  CXX Compiler Extension not found.")
		endif()
			message(STATUS "Disabling HDF5.")
		unset( HDF5_FOUND )
	endif()
else()
	message(STATUS "HDF5 not found, skip")
endif()

#####################################################################
#           ATLAS configuration
#####################################################################


option( ENABLE_CBLAS "Use Installed Linear Algebra Library" ON )

if( ENABLE_CBLAS )
	set(CBLAS_VENDOR FALSE)
	if( APPLE )
		set(CBLAS_VENDOR "Accelerate")
		set(CBLAS_INCLUDES "")
		set(CBLAS_LIBRARIES "-framework Accelerate" )
	else()
		#todo: do a propper vendor check
		find_library(OPENBLAS_LIBRARY openblas
			HINTS ${CBLAS_ROOT}/lib /opt/local/lib
		)
		find_library(CBLAS_LIBRARY cblas
			HINTS ${ATLAS_ROOT}/lib ${CBLAS_ROOT}/lib /opt/local/lib /usr/lib64/atlas/
		)
		find_library(CLAPACK_LIBRARY lapack
			HINTS ${ATLAS_ROOT}/lib ${CBLAS_ROOT}/lib /opt/local/lib /usr/lib64/atlas/
		)
		find_library(ATLAS_LIBRARY atlas
			HINTS ${ATLAS_ROOT}/lib ${CBLAS_ROOT}/lib /opt/local/lib /usr/lib64/atlas/
		)
		mark_as_advanced(
			OPENBLAS_LIBRARY
			CBLAS_LIBRARY
			CLAPACK_LIBRARY
			ATLAS_LIBRARY
		)
		#find the cblas.h include path
		if(CBLAS_LIBRARY )
			get_filename_component(CBLAS_LIB_PATH ${CBLAS_LIBRARY} PATH )
		elseif( OPENBLAS_LIBRARY)	
			get_filename_component(CBLAS_LIB_PATH ${OPENBLAS_LIBRARY} PATH )
		endif()
		if(CBLAS_LIB_PATH)
			find_file(CBLAS_INCLUDES cblas.h 
				PATHS ${CBLAS_LIB_PATH} ${CBLAS_LIB_PATH}/../include
			)
			get_filename_component(CBLAS_INCLUDES ${CBLAS_INCLUDES} PATH )
		endif()
		if(ATLAS_LIBRARY)
			get_filename_component(ATLAS_LIBRARY_PATH ${ATLAS_LIBRARY} PATH )
			find_file(CLAPACK_INCLUDES clapack.h 
				PATHS
				${ATLAS_LIBRARY_PATH} 
				${ATLAS_LIBRARY_PATH}/../include
				${ATLAS_LIBRARY_PATH}/../include/atlas
				${ATLAS_LIBRARY_PATH}/../../include/atlas
			)
			get_filename_component(CLAPACK_INCLUDES ${CLAPACK_INCLUDES} PATH )
			set(CBLAS_INCLUDES ${CBLAS_INCLUDES} ${CLAPACK_INCLUDES})
		endif()

		if( OPENBLAS_LIBRARY AND CBLAS_INCLUDES)
			set(CBLAS_VENDOR "OpenBLAS")
			set(CBLAS_LIBRARIES ${OPENBLAS_LIBRARY})
		elseif( CBLAS_LIBRARY AND CLAPACK_LIBRARY AND ATLAS_LIBRARY AND CBLAS_INCLUDES)
			set(CBLAS_VENDOR "ATLAS")
			set(CBLAS_LIBRARIES ${CLAPACK_LIBRARY} ${CBLAS_LIBRARY} ${ATLAS_LIBRARY})
		elseif( CBLAS_LIBRARY AND CBLAS_INCLUDES)
			#check that we can compile a basic program with the libraries we have found
			#vendor versions might come with additional libraries which would be bad.
			try_compile(CBLAS_COMPILE 
				"${PROJECT_BINARY_DIR}/cBlasCheck"
				"${CMAKE_SOURCE_DIR}/cBlasCheck.cpp"
				CMAKE_FLAGS "-DINCLUDE_DIRECTORIES=${CBLAS_INCLUDES}"
				LINK_LIBRARIES ${CBLAS_LIBRARY}
			)
			if(CBLAS_COMPILE)
				set(CBLAS_VENDOR "GENERIC")
				set(CBLAS_LIBRARIES ${CBLAS_LIBRARY})
			else()
				message(WARNING "Unknown CBLAS. Can not use it")
			endif()
		endif()
	endif()
	
	if(CBLAS_VENDOR)
		message(STATUS "CBLAS FOUND: " ${CBLAS_VENDOR} " with include directory " ${CBLAS_INCLUDES} )
		set(SHARK_USE_CBLAS 1)
		list(APPEND EXTRA_INCLUDE_DIRECTORIES ${CBLAS_INCLUDES} )
		list(APPEND LINK_LIBRARIES ${CBLAS_LIBRARIES})
		include_directories ( ${CBLAS_INCLUDES} )
	else()
		message(STATUS "No usable CBLAS Library found. No fast linear Algebra used.")
	endif()
	
	#Special setup for ATLAS
	if( CBLAS_VENDOR MATCHES "ATLAS" )
		set( SHARK_USE_ATLAS_LAPACK 1) # ATLAS always contains some LAPACK methods that we can use
		
		#check for full lapack
		set(CMAKE_REQUIRE_QUIET 1)
		set(CMAKE_REQUIRED_LIBRARIES ${CBLAS_LIBRARIES})
		check_function_exists(dsyev_ ATLAS_FULL_LAPACK)
		
		if( ATLAS_FULL_LAPACK )
			set( SHARK_USE_LAPACK 1)
			message(STATUS "Detected ATLAS with full LAPACK package. Using it!")
		endif()
	endif()
endif()
#####################################################################
#                       Static Code Analysis
#####################################################################

=== Test/CMakeLists.txt ===
#####################################################################
#       Shark Machine Learning Library                              #
#       Setup for unit testing                                      #
#       Test invocation: CTest                                      #
#       Test implementation: Boost UTF                              #
#####################################################################


#####################################################################
#       Configure logging of test restuls to XML                    #
#####################################################################
option( LOG_TEST_OUTPUT "Log test output to XML files." OFF )

#####################################################################
#   Adds a unit test for the shark library                          #
#   Param: SRC Source files for compilation                         #
#   Param: NAME Target name for the resulting executable            #
#   Output: Executable in ${SHARK}/Test/bin                         #
#                                                                   #
#       If OPT_LOG_TEST_OUTPUT is enabled, test log is written      #
#   to ${NAME_Log.xml} in ${SHARK}/Test/bin.                        #
#####################################################################
macro(SHARK_ADD_TEST SRC NAME)
   
  if( OPT_LOG_TEST_OUTPUT )
    set( XML_LOGGING_COMMAND_LINE_ARGS "--log_level=test_suite --log_format=XML --log_sink=${NAME}_Log.xml --report_level=no" )
  endif( OPT_LOG_TEST_OUTPUT )

  # Create the test executable
  add_executable( ${NAME} ${SRC} Models/derivativeTestHelper.h )
  target_link_libraries( ${NAME} shark)

  if(GCOV_CHECK)
    target_link_libraries( ${NAME} gcov)
  endif (GCOV_CHECK)

  # Add the test
  add_test( ${NAME} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${NAME} ${XML_LOGGING_COMMAND_LINE_ARGS} )

  set_target_properties(${NAME} PROPERTIES FOLDER "Tests")
  if(GCOV_CHECK)
    add_Test( ${NAME} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${NAME} ${XML_LOGGING_COMMAND_LINE_ARGS} COMMAND Coverage)
  endif (GCOV_CHECK)
endmacro()

# BLAS Tests
shark_add_test( LinAlg/BLAS/iterators.cpp BLAS_Iterators)
shark_add_test( LinAlg/BLAS/vector_assign.cpp BLAS_Vector_Assign)
shark_add_test( LinAlg/BLAS/matrix_assign.cpp BLAS_Matrix_Assign)
shark_add_test( LinAlg/BLAS/compressed_vector.cpp BLAS_Compressed_Vector)
shark_add_test( LinAlg/BLAS/triangular_matrix.cpp BLAS_Triangular_Matrix)
shark_add_test( LinAlg/BLAS/compressed_matrix.cpp BLAS_Compressed_Matrix)
shark_add_test( LinAlg/BLAS/vector_proxy.cpp BLAS_Vector_Proxy)
shark_add_test( LinAlg/BLAS/matrix_proxy.cpp BLAS_Matrix_Proxy)
shark_add_test( LinAlg/BLAS/vector_expression.cpp BLAS_Vector_Expression)
shark_add_test( LinAlg/BLAS/axpy_prod.cpp BLAS_Axpy_Prod)
shark_add_test( LinAlg/BLAS/triangular_prod.cpp BLAS_Triangular_Prod)

# LinAlg Tests
shark_add_test( LinAlg/DiagonalMatrix.cpp LinAlg_DiagonalMatrix)
shark_add_test( LinAlg/sumRows.cpp LinAlg_SumRows)
shark_add_test( LinAlg/Proxy.cpp LinAlg_Proxy )
shark_add_test( LinAlg/repeat.cpp LinAlg_Repeat)
shark_add_test( LinAlg/rotations.cpp LinAlg_rotations )
shark_add_test( LinAlg/permute.cpp LinAlg_Permutations )
shark_add_test( LinAlg/KernelMatrix.cpp LinAlg_KernelMatrix )
shark_add_test( LinAlg/Metrics.cpp LinAlg_Metrics)
shark_add_test( LinAlg/RQ.cpp LinAlg_RQ )
shark_add_test( LinAlg/eigensymm.cpp LinAlg_eigensymm )
shark_add_test( LinAlg/svd.cpp LinAlg_svd )
shark_add_test( LinAlg/choleskyDecomposition.cpp LinAlg_choleskyDecomposition)
shark_add_test( LinAlg/solve.cpp LinAlg_solve)
shark_add_test( LinAlg/BLAS/transformations.cpp BLAS_Transformations)
shark_add_test( LinAlg/Initialize.cpp LinAlg_Initialize)
shark_add_test( LinAlg/LRUCache.cpp LinAlg_LRUCache )
shark_add_test( LinAlg/PartlyPrecomputedMatrix.cpp LinAlg_PartlyPrecomputedMatrix )

#Algorithms tests 
#Direct Search
shark_add_test( Algorithms/DirectSearch/CMA.cpp DirectSearch_CMA )
shark_add_test( Algorithms/DirectSearch/CMSA.cpp DirectSearch_CMSA )
shark_add_test( Algorithms/DirectSearch/ElitistCMA.cpp DirectSearch_ElitistCMA )
shark_add_test( Algorithms/DirectSearch/CrossEntropyMethod.cpp DirectSearch_CrossEntropyMethod )
shark_add_test( Algorithms/DirectSearch/VDCMA.cpp DirectSearch_VDCMA )
shark_add_test( Algorithms/DirectSearch/MOCMA.cpp DirectSearch_MOCMA )
shark_add_test( Algorithms/DirectSearch/SteadyStateMOCMA.cpp DirectSearch_SteadyStateMOCMA )
shark_add_test( Algorithms/DirectSearch/RealCodedNSGAII.cpp DirectSearch_RealCodedNSGAII )
shark_add_test( Algorithms/DirectSearch/SMS-EMOA.cpp DirectSearch_SMS-EMOA )
shark_add_test( Algorithms/DirectSearch/FastNonDominatedSort.cpp DirectSearch_FastNonDominatedSort )
shark_add_test( Algorithms/DirectSearch/ParetoDominanceComparator.cpp DirectSearch_ParetoDominanceComparator )

# Direct Search Operator tests
shark_add_test( Algorithms/DirectSearch/Operators/Selection/Selection.cpp DirectSearch_Selection )
shark_add_test( Algorithms/DirectSearch/Operators/Selection/IndicatorBasedSelection.cpp DirectSearch_IndicatorBasedSelection )
shark_add_test( Algorithms/DirectSearch/Operators/Mutation/BitflipMutation.cpp DirectSearch_BitflipMutation )
shark_add_test( Algorithms/DirectSearch/Operators/PenalizingEvaluator.cpp DirectSearch_PenalizingEvaluator )

# Direct Search Indicator tests
shark_add_test( Algorithms/DirectSearch/Indicators/HypervolumeIndicator.cpp DirectSearch_HypervolumeIndicator )

# GradientDescent
shark_add_test( Algorithms/GradientDescent/LineSearch.cpp GradDesc_LineSearch )
shark_add_test( Algorithms/GradientDescent/BFGS.cpp GradDesc_BFGS )
shark_add_test( Algorithms/GradientDescent/LBFGS.cpp GradDesc_LBFGS )
shark_add_test( Algorithms/GradientDescent/CG.cpp GradDesc_CG )
shark_add_test( Algorithms/GradientDescent/Rprop.cpp GradDesc_Rprop )
shark_add_test( Algorithms/GradientDescent/SteepestDescent.cpp GradDesc_SteepestDescent )


# Trainers
shark_add_test( Algorithms/Trainers/CSvmTrainer.cpp Trainers_CSvmTrainer )
shark_add_test( Algorithms/Trainers/FisherLDA.cpp Trainers_FisherLDA )
shark_add_test( Algorithms/Trainers/KernelMeanClassifier.cpp Trainers_KernelMeanClassifier )
shark_add_test( Algorithms/Trainers/EpsilonSvmTrainer.cpp Trainers_EpsilonSvmTrainer )
shark_add_test( Algorithms/Trainers/OneClassSvmTrainer.cpp Trainers_OneClassSvmTrainer )
shark_add_test( Algorithms/Trainers/RegularizationNetworkTrainer.cpp Trainers_RegularizationNetworkTrainer )
shark_add_test( Algorithms/Trainers/LDA.cpp Trainers_LDA )
shark_add_test( Algorithms/Trainers/LinearRegression.cpp Trainers_LinearRegression )
shark_add_test( Algorithms/Trainers/McSvmTrainer.cpp Trainers_McSvmTrainer )
shark_add_test( Algorithms/Trainers/LinearSvmTrainer.cpp Trainers_LinearSvmTrainer )
shark_add_test( Algorithms/Trainers/NBClassifierTrainerTests.cpp Trainers_NBClassifier )
shark_add_test( Algorithms/Trainers/Normalization.cpp Trainers_Normalization )
shark_add_test( Algorithms/Trainers/KernelNormalization.cpp Trainers_KernelNormalization )
shark_add_test( Algorithms/Trainers/SigmoidFit.cpp Trainers_SigmoidFit )
shark_add_test( Algorithms/Trainers/PCA.cpp Trainers_PCA )
shark_add_test( Algorithms/Trainers/Perceptron.cpp Trainers_Perceptron )
shark_add_test( Algorithms/Trainers/MissingFeatureSvmTrainerTests.cpp Trainers_MissingFeatureSvmTrainer )
shark_add_test( Algorithms/Trainers/Budgeted/AbstractBudgetMaintenanceStrategy_Test.cpp Trainers_AbstractBudgetMaintenanceStrategy )
shark_add_test( Algorithms/Trainers/Budgeted/MergeBudgetMaintenanceStrategy_Test.cpp MergeBudgetMaintenanceStrategy )
shark_add_test( Algorithms/Trainers/Budgeted/RemoveBudgetMaintenanceStrategy_Test.cpp RemoveBudgetMaintenanceStrategy )
shark_add_test( Algorithms/Trainers/Budgeted/KernelBudgetedSGDTrainer_Test.cpp KernelBudgetedSGDTrainer )

# Misc algorithms
shark_add_test( Algorithms/GridSearch.cpp Algorithms_GridSearch )
shark_add_test( Algorithms/Hypervolume.cpp Algorithms_Hypervolume )
shark_add_test( Algorithms/nearestneighbors.cpp Algorithms_NearestNeighbor )
shark_add_test( Algorithms/KMeans.cpp Algorithms_KMeans )
shark_add_test( Algorithms/JaakkolaHeuristic.cpp Algorithms_JaakkolaHeuristic )

# Models
shark_add_test( Models/ConcatenatedModel.cpp Models_ConcatenatedModel )
shark_add_test( Models/FFNet.cpp Models_FFNet )
shark_add_test( Models/Autoencoder.cpp Models_Autoencoder )
shark_add_test( Models/TiedAutoencoder.cpp Models_TiedAutoencoder )
shark_add_test( Models/LinearModel.cpp Models_LinearModel )
shark_add_test( Models/LinearNorm.cpp Models_LinearNorm )
shark_add_test( Models/ConvexCombination.cpp Models_ConvexCombination )
shark_add_test( Models/NBClassifierTests.cpp Models_NBClassifier )
#shark_add_test( Models/OnlineRNNet.cpp Models_OnlineRNNet )
shark_add_test( Models/RBFLayer.cpp Models_RBFLayer ) 
shark_add_test( Models/RNNet.cpp Models_RNNet ) 
shark_add_test( Models/CMAC.cpp Models_CMAC )
shark_add_test( Models/MeanModel.cpp Models_MeanModel )

shark_add_test( Models/SigmoidModel.cpp Models_SigmoidModel )
shark_add_test( Models/Softmax.cpp Models_Softmax )
shark_add_test( Models/SoftNearestNeighborClassifier.cpp Models_SoftNearestNeighborClassifier )
shark_add_test( Models/Kernels/KernelExpansion.cpp Models_KernelExpansion )
shark_add_test( Models/NearestNeighborRegression.cpp Models_NearestNeighborRegression )
shark_add_test( Models/OneVersusOneClassifier.cpp Models_OneVersusOneClassifier )

# Kernels
shark_add_test( Models/Kernels/GaussianRbfKernel.cpp Models_GaussianKernel )
shark_add_test( Models/Kernels/LinearKernel.cpp Models_LinearKernel )
shark_add_test( Models/Kernels/NormalizedKernel.cpp Models_NormalizedKernel )
shark_add_test( Models/Kernels/MonomialKernel.cpp Models_MonomialKernel )
shark_add_test( Models/Kernels/PolynomialKernel.cpp Models_PolynomialKernel )
shark_add_test( Models/Kernels/ScaledKernel.cpp Models_ScaledKernel )
shark_add_test( Models/Kernels/WeightedSumKernel.cpp Models_WeightedSumKernel )
shark_add_test( Models/Kernels/ProductKernel.cpp Models_ProductKernel )
shark_add_test( Models/Kernels/ArdKernel.cpp Models_ArdKernel )
shark_add_test( Models/Kernels/MklKernel.cpp Models_MklKernel )
shark_add_test( Models/Kernels/SubrangeKernel.cpp Models_SubrangeKernel )
shark_add_test( Models/Kernels/DiscreteKernel.cpp Models_DiscreteKernel )
shark_add_test( Models/Kernels/MultiTaskKernel.cpp Models_MultiTaskKernel )
shark_add_test( Models/Kernels/ModelKernel.cpp Models_ModelKernel )

# KernelMethods
shark_add_test( Models/Kernels/KernelHelpers.cpp Models_KernelHelpers )
shark_add_test( Models/Kernels/KernelNearestNeighborClassifier.cpp Models_KernelNearestNeighborClassifier )
shark_add_test( Models/Kernels/KernelNearestNeighborRegression.cpp Models_KernelNearestNeighborRegression )
shark_add_test( Models/Kernels/EvalSkipMissingFeaturesTests.cpp Models_EvalSkipMissingFeatures )
shark_add_test( Models/Kernels/MissingFeaturesKernelExpansionTests.cpp Models_MissingFeaturesKernelExpansion )
shark_add_test( Models/Kernels/CSvmDerivative.cpp Models_CSvmDerivative )

# Trees
shark_add_test( Models/RFClassifier.cpp Models_RFClassifier )
shark_add_test( Models/CARTClassifier.cpp Models_CARTClassifier )

# Core tests
#shark_add_test( Core/ScopedHandleTests.cpp Core_ScopedHandleTests )
shark_add_test( Core/Iterators.cpp Core_Iterators )
shark_add_test( Core/Math.cpp Core_Math )

# Data Tests
shark_add_test( Data/Csv.cpp Data_Csv )
shark_add_test( Data/Bootstrap.cpp Data_Bootstrap )
shark_add_test( Data/CVDatasetTools.cpp Data_CVDatasetTools )
shark_add_test( Data/Dataset.cpp Data_Dataset )
shark_add_test( Data/DataView.cpp Data_DataView )
shark_add_test( Data/LabelOrder_Test.cpp Data_LabelOrder )
shark_add_test( Data/Statistics.cpp Data_Statistics )
if(HDF5_FOUND)
  shark_add_test( Data/HDF5Tests.cpp Data_HDF5 )
endif()
shark_add_test( Data/SparseData.cpp Data_SparseData )
shark_add_test( Data/ExportKernelMatrix.cpp Data_ExportKernelMatrix )

#Objective Functions
shark_add_test( ObjectiveFunctions/ErrorFunction.cpp ObjFunct_ErrorFunction )

=== src/CMakeLists.txt ===
# Glob the files
file( GLOB_RECURSE SHARK_SRCS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.cpp)
file(GLOB_RECURSE SHARK_HEADERS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} ../include/*.h ../include/*.hpp ../include/*.inl)

# Group the source for MSVC
foreach(FILE ${SHARK_SRCS}) 
    # Get the directory of the source file
    get_filename_component(PARENT_DIR "${FILE}" PATH)
    # Make sure we are using windows slashes
    string(REPLACE "/" "\\" GROUP "${PARENT_DIR}")

    set(GROUP "src\\${GROUP}")

    source_group("${GROUP}" FILES "${FILE}")
endforeach()
#Also Group the Header Files
foreach(FILE ${SHARK_HEADERS}) 
    # Get the directory of the source file
    get_filename_component(PARENT_DIR "${FILE}" PATH)

	string(REPLACE "../" "" GROUP "${PARENT_DIR}")

    # Make sure we are using windows slashes
    string(REPLACE "/" "\\" GROUP "${GROUP}")

    source_group("${GROUP}" FILES "${FILE}")
endforeach()



# Create the shark library
add_library( shark ${SHARK_SRCS} ${SHARK_HEADERS} )
target_link_libraries( shark ${LINK_LIBRARIES})

set_target_properties( shark PROPERTIES DEBUG_POSTFIX _debug )

if( WIN32 )
  set_target_properties( shark PROPERTIES DEBUG_PREFIX ../ )
endif()

# Add the version executable
add_executable(SharkVersion Core/Version.cpp)
target_link_libraries(SharkVersion shark)

# Install the library
set_target_properties( shark PROPERTIES
	VERSION ${SHARK_VERSION}
	SOVERSION ${SHARK_SOVERSION})

install(TARGETS shark
	    EXPORT SharkTargets
	    RUNTIME DESTINATION bin
	    LIBRARY DESTINATION lib
	    ARCHIVE DESTINATION lib)
	
install(TARGETS SharkVersion
	    RUNTIME DESTINATION bin)

=== doc/sphinx_pages/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/mttest.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/mttest.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/mttest"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/mttest"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	make -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== doc/tutToRst/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED( VERSION 2.8 )

ADD_EXECUTABLE( tut2rst
	tut2rst.cpp
)

=== debian/changelog ===
shark (3.1.4+ds1-1ubuntu1) bionic; urgency=medium

  * Allow stderr output in autpkgtests to ignore
    notes emitted by GCC7 on armhf
  * Lower precision of some tests to avoid FTBFS with Boost 1.65

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 26 Jan 2018 14:47:48 +0000

shark (3.1.4+ds1-1) unstable; urgency=medium

  * New upstream version 3.1.4+ds1 (Closes: #853658)
  * Add missing Built-Using metadata for the docs
  * Add support for the nodoc build profile
  * Build the docs with Python 3
  * Bump the standards version to 4.1.1

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 12 Oct 2017 10:11:12 +0100

=== debian/rules ===
--- 
+++ 
@@ -24,15 +24,6 @@
 CMAKE_BUILD_OPTIONS += -DBUILD_TESTING=OFF
 endif
 
-export CC=gcc-6
-export CXX=g++-6
-
-DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
-ifeq ($(DEB_HOST_ARCH), ppc64el)
-export DEB_CXXFLAGS_MAINT_STRIP = -O3
-export DEB_CXXFLAGS_MAINT_APPEND = -O2 -Wall -pedantic
-endif
-
 %:
 	dh $@
 
@@ -42,20 +33,24 @@
 		-DBUILD_EXAMPLES=OFF
 
 override_dh_auto_configure-indep:
+ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
 	dh_auto_configure -- $(CMAKE_BUILD_OPTIONS) \
 		-DBUILD_DOCUMENTATION=ON \
 		-DBUILD_EXAMPLES=ON \
 		-DOPT_INSTALL_DOCUMENTATION=ON
+endif
 
 override_dh_auto_test:
 	dh_auto_test -- ARGS+="-LE 'slow'"
 
 override_dh_installdocs-indep:
 	dh_installdocs --indep
+ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
 	dh_doxygen --indep \
 		/usr/share/doc/shark-doc/html/doxygen_pages/html
 	dh_sphinxdoc --indep --exclude=MathJax.js \
 		/usr/share/doc/shark-doc/html/sphinx_pages
+endif
 
 override_dh_compress:
 	dh_compress --exclude=examples

=== debian/tests/control ===
--- 
+++ 
@@ -10,6 +10,4 @@
          libboost-thread-dev,
          libshark-dev,
          pkg-config,
-         shark-doc,
-         gcc-6,
-         g++-6
+         shark-doc

=== debian/watch ===
version=3
opts=repacksuffix=+ds1,\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\d+)?$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/Shark-$1\.tar\.gz/ \
https://github.com/Shark-ML/Shark/tags .*/v?(\d\S*)\.tar\.gz
